; Multiple MPH

		.include	doscall.mac
		.request	DecHUPAIR,EncHUPAIR

		.xref	DecodeHUPAIR
		.xref	EncodeHUPAIR,SetHUPAIR

LF		.equ	10
CR		.equ	13

HUPAIR_BUF_SIZE	.equ	32*1024
STACK_SIZE	.equ	16*1024

		.offset	0
exec_name_buf	.ds.b	90
		.ds.b	8			#HUPAIR\0
arg_enc_buf	.ds.b	HUPAIR_BUF_SIZE
arg_dec_buf	.ds.b	HUPAIR_BUF_SIZE
		.ds.b	STACK_SIZE
		.even
work_size

		.text
start_
		bra	@f
		.dc.b	'#HUPAIR',0
@@
		pea	(title_mes,pc)
		DOS	_PRINT
		addq.l	#4,sp

		tst.b	(a2)+
		beq	print_usage

		lea	(end_-start_+$f0+work_size),a1
		move.l	a1,-(sp)
		pea	(16,a0)
		DOS	_SETBLOCK
		tst.l	d0
		bmi	setblock_error
		lea	(16,a0,a1.l),sp

		lea	(a2),a0
		lea	(end_,pc),a1
		adda.l	#arg_dec_buf,a1
		bsr	DecodeHUPAIR
		beq	print_usage
		subq	#1,d0
		move	d0,d7

		lea	(end_+arg_enc_buf,pc),a0	exec(2) ̎̓_~[
		lea	(end_+exec_name_buf,pc),a2	st@C
		move.l	#'MPH'.shl.8,(a2)
		moveq	#2,d0
		bsr	dos_exec
		bmi	mph_search_error	Ȃ

		move.l	#HUPAIR_BUF_SIZE,d0
		moveq	#1,d1			ɈGR[h
		moveq	#0,d6			.OFMT/t@C wς݃tO
arg_loop
		tst.b	(a1)
		beq	next_arg		̈
		cmpi.b	#'-',(a1)
		beq	add_option		IvV̎ d7 ZbgȂ

		tas	d6			*.OFMT ߋɎw肳ꂽH
		bne	exec_mph
*.ofmt ̎w肩ׂ
		cmpi.b	#'.',(a1)
		bne	exec_mph		ʂ̃t@C

		move.b	(1,a1),d0
		beq	exec_mph		.
		lsl	#8,d0
		move.b	(2,a1),d0
		beq	exec_mph		.?
		move.b	(3,a1),d2
		bne	is_ofmt_mag		.???

		cmpi	#'PI',d0
		beq	add_option		.PI
		cmpi	#'HG',d0
		beq	add_option		.HG
		bra	exec_mph
is_ofmt_mag
		cmpi	#'MA',d0
		bne	exec_mph
		cmpi.b	#'G',d2
		beq	add_option		.MAG
exec_mph
		movem.l	d0-d7/a0-a6,-(sp)
		bsr	EncodeHUPAIR		t@Cǉ
		bmi	encbuf_flow

		lea	(end_+arg_enc_buf,pc),a1
		move.l	#HUPAIR_BUF_SIZE,d1
		bsr	SetHUPAIR
		bmi	encbuf_flow

		moveq	#0,d0
		lea	(a1),a0			R}hC
		bsr	dos_exec
		bmi	exec_error

		movem.l	(sp)+,d0-d7/a0-a6
		bra	@f
add_option
		bsr	EncodeHUPAIR
		bmi	encbuf_flow
@@
		tst.b	(a1)+
		bne	@b			̈ɐi߂
next_arg
		dbra	d7,arg_loop

		DOS	_EXIT

; Tu[` ---------------------------------

dos_exec
		clr.l	-(sp)
		move.l	a0,-(sp)
		move.l	a2,-(sp)
		move	d0,-(sp)
		DOS	_EXEC
		lea	(14,sp),sp
		tst.l	d0
		rts

; G[\ -----------------------------------

print_usage
		pea	(usage_mes,pc)
		bra	@f
setblock_error
		pea	(setblock_err_mes,pc)
		bra	@f
mph_search_error
		pea	(mph_search_err_mes,pc)
		bra	@f
encbuf_flow
		pea	(encbuf_flow_mes,pc)
		bra	@f
exec_error
		pea	(exec_err_mes,pc)
		bra	@f
@@
		DOS	_PRINT
		DOS	_EXIT

; f[^ ---------------------------------------

		.data
title_mes
		.dc.b	'Multiple MPH version 0.21 March 21st,1995 Tachibana Eririn.',CR,LF,0
usage_mes
		.dc.b	' usage : mmph [option] [.format(PI/HG/MAG)] files',CR,LF,0
setblock_err_mes
		.dc.b	'Setblock error',CR,LF,0
mph_search_err_mes
		.dc.b	'MPH ܂',CR,LF,0
encbuf_flow_mes
		.dc.b	'HUPAIR GR[hobt@܂',CR,LF,0
exec_err_mes
		.dc.b	'MPH so܂',CR,LF,0

		.even
end_
		.end

; I ---------------------------------------
